setwd("g:\\elhorst_code")
cigar<-read.table(file="cigardemo.txt", sep="\t", h=T)
w<-as.matrix(read.table(file="spat-sym-us.txt", sep="\t", h=F))
save(w, file="w.rda")
save(cigar, file="cigar.rda")

fm<-logc~logp+logpn+logy
library(spdep)
lw<-mat2listw(w)

library(splm)

## pooled
sarfemod<-spfeml(fm, data=cigar, index=c("region","year"), listw=lw)
summary(sarfemod)

sarfemod<-spfeml(fm, data=cigar, index=c("region","year"), listw=lw, effects="spfe")
summary(sarfemod)

semfemod<-spfeml(fm, data=cigar, index=c("region","year"), listw=lw, model="error", effects="spfe")
summary(semfemod)

semremod<-spreml(fm, data=cigar, index=c("region","year"), w=w, err="semre")
summary(semremod)

sarremod<-spreml(fm, data=cigar, index=c("region","year"), w=w, err="re", lag=T)

semsrmod<-spreml(fm, data=cigar, index=c("region","year"), w=w, err="semsr")
summary(semsrmod)

