## replicate examples from Elhorst's site, file demopanelscompare.m

library(splm)
wcig <- as.matrix(read.table("z:/GIANNI/Econometrica/esempi/cigar/elhorst/spat-sym-us.txt"))

wcig <- wcig/apply(wcig, 1, sum)
## standardization ok

## read data
cigar <- read.table("z:/GIANNI/Econometrica/esempi/cigar/elhorst/cigardemo.txt", h=T)

fm <- logc ~ logp+logpn+logy

############# begin examples ###############
## legend: 
## - spfe spatial (=individual) fixed effects
## - tpfe time fixed effects
## - sptpfe twoway fixed effects
## - RE random (individual) effects

## SAR panel spfe

lwcig <- mat2listw(wcig)

sarfe <- spml(fm, cigar, listw=lwcig, model="within", effect="individual",
              spatial.error="none", lag=TRUE)
summary(sarfe)


## SEM panel spfe

semfe <- spml(fm, cigar, listw=lwcig, model="within", effect="individual",
              spatial.error="b", lag=FALSE)
summary(semfe)


## SAR panel tpfe

sartfe <- spml(fm, cigar, listw=lwcig, model="within", effect="time",
              spatial.error="none", lag=TRUE)
summary(sartfe)


## SEM panel tpfe

semtfe <- spml(fm, cigar, listw=lwcig, model="within", effect="time",
              spatial.error="b", lag=FALSE)
summary(semtfe)


## SAR panel sptpfe

sar2fe <- spml(fm, cigar, listw=lwcig, model="within", effect="twoways",
              spatial.error="none", lag=TRUE)
summary(sar2fe)


## SEM panel sptpfe

sem2fe <- spml(fm, cigar, listw=lwcig, model="within", effect="twoways",
              spatial.error="b", lag=FALSE)
summary(sem2fe)


## SAR panel pooling

sarpool <- spml(fm, cigar, listw=lwcig, model="pooling",
              spatial.error="none", lag=TRUE)
summary(sarpool)


## SEM panel pool

sempool <- spml(fm, cigar, listw=lwcig, model="pooling",
              spatial.error="b", lag=FALSE)
summary(sempool)


## SAR panel RE

sarre <- spml(fm, cigar, listw=lwcig, model="random",
              spatial.error="none", lag=TRUE)
summary(sarre)


## SEM panel RE

semre <- spml(fm, cigar, listw=lwcig, model="random",
              spatial.error="b", lag=FALSE)
summary(semre)


