
monteJSS <- function(n., t., sarparms = c(-0.6, 0, 0.6),
                     semparms = sarparms,
                     nrep = 100, marker = 100,
                     target.dir = "D:/test/",
                     models = 1:5) {

source("dgp.R")
source("dgp2.R")

library(splm)
data(usaww)
usalw <- mat2listw(usaww)

## formula

 fm <- y~x1+x2


####### monte ########

print(date())

set.seed(12345)

for(sarp in sarparms) {
 for(semp in semparms) {

if(1 %in% models) {
## saremre

vcres <- vector("list", nrep)
for(i in 1:nrep) {
 dati <- dgp(n., t., usaww, beta=c(1,1,1), sar=sarp, sd.mu=2, ar.e=0, lambda=semp, add.e=0, unif.b=c(-7.5, 7.5))
 vcres[[i]] <- try(spml(fm, dati, listw=usalw, model="random",lag=T, spatial.error="b"))
 if(i%%marker==0) print(i)
}

vcresfile <- paste("vcres_saremre_", as.character(sarp), "_", as.character(semp), ".rda", sep="")
save(vcres, file=paste(target.dir,vcresfile,sep=""))
print(vcresfile)
}

if(2 %in% models) {
## sarem2re

vcres <- vector("list", nrep)
for(i in 1:nrep) {
 dati <- dgp2(n., t., usaww, beta=c(1,1,1), sar=sarp, sd.mu=2, ar.e=0, lambda=semp, add.e=0, unif.b=c(-7.5, 7.5))
 vcres[[i]] <- try(spml(fm, dati, listw=usalw, model="random",lag=T, spatial.error="kkp"))
 if(i%%marker==0) print(i)
}

vcresfile <- paste("vcres_sarem2re_", as.character(sarp), "_", as.character(semp), ".rda", sep="")
save(vcres, file=paste(target.dir,vcresfile,sep=""))
print(vcresfile)
}

if(3 %in% models) {
## saremfe

vcres <- vector("list", nrep)
for(i in 1:nrep) {
 dati <- dgp(n., t., usaww, beta=c(1,1,1), sar=sarp, sd.mu=2, ar.e=0, lambda=semp, add.e=0, unif.b=c(-7.5, 7.5))
 vcres[[i]] <- try(spml(fm, dati, listw=usalw, model="within",lag=T, spatial.error="b"))
 if(i%%marker==0) print(i)
}

vcresfile <- paste("vcres_saremfe_", as.character(sarp), "_", as.character(semp), ".rda", sep="")
save(vcres, file=paste(target.dir,vcresfile,sep=""))
print(vcresfile)
}

if(4 %in% models) {
## saremregm

vcres <- vector("list", nrep)
for(i in 1:nrep) {
 dati <- dgp2(n., t., usaww, beta=c(1,1,1), sar=sarp, sd.mu=2, ar.e=0, lambda=semp, add.e=0, unif.b=c(-7.5, 7.5))
 vcres[[i]] <- try(spgm(fm, dati, listw=usalw, model="random",lag=TRUE, spatial.error=TRUE))
 if(i%%marker==0) print(i)
}

vcresfile <- paste("vcres_saremregm_", as.character(sarp), "_", as.character(semp), ".rda", sep="")
save(vcres, file=paste(target.dir,vcresfile,sep=""))
print(vcresfile)
}

if(5 %in% models) {
## saremfegm

vcres <- vector("list", nrep)
for(i in 1:nrep) {
 dati <- dgp2(n., t., usaww, beta=c(1,1,1), sar=sarp, sd.mu=2, ar.e=0, lambda=semp, add.e=0, unif.b=c(-7.5, 7.5))
 vcres[[i]] <- try(spgm(fm, dati, listw=usalw, model="within",lag=TRUE, spatial.error=TRUE))
 if(i%%marker==0) print(i)
 }

vcresfile <- paste("vcres_saremfegm_", as.character(sarp), "_", as.character(semp), ".rda", sep="")
save(vcres, file=paste(target.dir,vcresfile,sep=""))
print(vcresfile)
}

 }
}



print(date())

}


