## reproduces tables 4-8 in the JSS paper 
## unlike vcsimdescribe, all printing is done at the end

sarparms <- c(-0.4, 0.2, 0.6) # ...or whatever
semparms <- sarparms

## init results' matrices
## ...for lambda
resmeanl <- matrix(ncol=length(sarparms), nrow=length(semparms))
ressdl <- resmeanl
## ...and rho
resmeanr <- matrix(ncol=length(sarparms), nrow=length(semparms))
ressdr <- resmeanr

## init results' matrices for bias and RMSE
## ...for lambda
resbiasl <- matrix(ncol=length(sarparms), nrow=length(semparms))
resrmsel <- resbiasl
## ...and rho
resbiasr <- matrix(ncol=length(sarparms), nrow=length(semparms))
resrmser <- resbiasr
## set results' dir
resdir <- "D:/test/coef/"

##################### RE(B) Table 4 #######################

modelname <- "saremre"

## this snippet good for saremre, sarem2re

for(i in 1:length(sarparms)) {
  for(j in 1:length(semparms)) {

    load(paste(resdir, "vcres_", modelname, "_", as.character(sarparms[i]),
               "_", as.character(semparms[j]), ".rda", sep=""))


    emp.lambda <- unlist(lapply(vcres, "[[", "arcoef"))
    emp.rho <- unlist(lapply(lapply(vcres, "[[", "errcomp"), "[[", "rho"))
    resmeanl[j,i] <-  mean(emp.lambda) # lambda in columns
    ressdl[j,i] <- sd(emp.lambda) # idem
    resmeanr[j,i] <-  mean(emp.rho) # rho in rows
    ressdr[j,i] <- sd(emp.rho) # idem

    ## bias and RMSE
    resbiasl[j,i] <- mean(emp.lambda)-sarparms[i]
    resrmsel[j,i] <- sqrt(mean((emp.lambda-sarparms[i])^2))
    resbiasr[j,i] <- mean(emp.rho)-semparms[j]
    resrmser[j,i] <- sqrt(mean((emp.rho-semparms[j])^2))

  }
}

saremretab <- list(ml=resmeanl, sl=ressdl, mr=resmeanr, sr=ressdr)
saremretab2 <- list(ml=resbiasl, sl=resrmsel, mr=resbiasr, sr=resrmser)

####################### RE(KKP) Table 6 ########################

modelname <- "sarem2re"

## this snippet good for saremre, sarem2re

for(i in 1:length(sarparms)) {
  for(j in 1:length(semparms)) {

    load(paste(resdir, "vcres_", modelname, "_", as.character(sarparms[i]),
               "_", as.character(semparms[j]), ".rda", sep=""))


    emp.lambda <- unlist(lapply(vcres, "[[", "arcoef"))
    emp.rho <- unlist(lapply(lapply(vcres, "[[", "errcomp"), "[[", "rho"))
    resmeanl[j,i] <-  mean(emp.lambda) # lambda in columns
    ressdl[j,i] <- sd(emp.lambda) # idem
    resmeanr[j,i] <-  mean(emp.rho) # rho in rows
    ressdr[j,i] <- sd(emp.rho) # idem

    ## bias and RMSE
    resbiasl[j,i] <- mean(emp.lambda)-sarparms[i]
    resrmsel[j,i] <- sqrt(mean((emp.lambda-sarparms[i])^2))
    resbiasr[j,i] <- mean(emp.rho)-semparms[j]
    resrmser[j,i] <- sqrt(mean((emp.rho-semparms[j])^2))

  }
}

sarem2retab <- list(ml=resmeanl, sl=ressdl, mr=resmeanr, sr=ressdr)
sarem2retab2 <- list(ml=resbiasl, sl=resrmsel, mr=resbiasr, sr=resrmser)

####################### FE Table 5 ############################

modelname <- "saremfe"
## this one good for saremfe

for(i in 1:length(sarparms)) {
  for(j in 1:length(semparms)) {

    load(paste(resdir, "vcres_", modelname, "_", as.character(sarparms[i]), "_",
               as.character(semparms[j]), ".rda", sep=""))


    emp.lambda <- unlist(lapply(lapply(vcres, "[[", "coefficients"), "[", "lambda"))
    emp.rho <- unlist(lapply(lapply(vcres, "[[", "coefficients"), "[", "rho"))
    resmeanl[j,i] <-  mean(emp.lambda) # lambda in columns
    ressdl[j,i] <- sd(emp.lambda) # idem
    resmeanr[j,i] <-  mean(emp.rho) # rho in rows
    ressdr[j,i] <- sd(emp.rho) # idem

    ## bias and RMSE
    resbiasl[j,i] <- mean(emp.lambda)-sarparms[i]
    resrmsel[j,i] <- sqrt(mean((emp.lambda-sarparms[i])^2))
    resbiasr[j,i] <- mean(emp.rho)-semparms[j]
    resrmser[j,i] <- sqrt(mean((emp.rho-semparms[j])^2))

  }
}

saremfetab <- list(ml=resmeanl, sl=ressdl, mr=resmeanr, sr=ressdr)
saremfetab2 <- list(ml=resbiasl, sl=resrmsel, mr=resbiasr, sr=resrmser)

######################## RE GM Table 7 ##########################

modelname <- "saremregm"
## this one good for saremre by gm

for(i in 1:length(sarparms)) {
  for(j in 1:length(semparms)) {

    load(paste(resdir, "vcres_", modelname, "_", as.character(sarparms[i]), "_",
               as.character(semparms[j]), ".rda", sep=""))


    emp.lambda <- unlist(lapply(lapply(vcres, "[[", "coefficients"), "[", "lambda"))
    emp.rho <- unlist(lapply(lapply(vcres, "[[", "errcomp"), "[", 1))
    resmeanl[j,i] <-  mean(emp.lambda) # lambda in columns
    ressdl[j,i] <- sd(emp.lambda) # idem
    resmeanr[j,i] <-  mean(emp.rho) # rho in rows
    ressdr[j,i] <- sd(emp.rho) # idem

    ## bias and RMSE
    resbiasl[j,i] <- mean(emp.lambda)-sarparms[i]
    resrmsel[j,i] <- sqrt(mean((emp.lambda-sarparms[i])^2))
    resbiasr[j,i] <- mean(emp.rho)-semparms[j]
    resrmser[j,i] <- sqrt(mean((emp.rho-semparms[j])^2))

  }
}

saremregmtab <- list(ml=resmeanl, sl=ressdl, mr=resmeanr, sr=ressdr)
saremregmtab2 <- list(ml=resbiasl, sl=resrmsel, mr=resbiasr, sr=resrmser)

########################## FE GM Table 8 ##########################

modelname <- "saremfegm"
## this one good for saremfe by gm

for(i in 1:length(sarparms)) {
  for(j in 1:length(semparms)) {

    load(paste(resdir, "vcres_", modelname, "_", as.character(sarparms[i]), "_",
               as.character(semparms[j]), ".rda", sep=""))


    emp.lambda <- unlist(lapply(lapply(vcres, "[[", "coefficients"), "[", "lambda"))
    emp.rho <- unlist(lapply(lapply(vcres, "[[", "errcomp"), "[", 1))
    resmeanl[j,i] <-  mean(emp.lambda) # lambda in columns
    ressdl[j,i] <- sd(emp.lambda) # idem
    resmeanr[j,i] <-  mean(emp.rho) # rho in rows
    ressdr[j,i] <- sd(emp.rho) # idem

    ## bias and RMSE
    resbiasl[j,i] <- mean(emp.lambda)-sarparms[i]
    resrmsel[j,i] <- sqrt(mean((emp.lambda-sarparms[i])^2))
    resbiasr[j,i] <- mean(emp.rho)-semparms[j]
    resrmser[j,i] <- sqrt(mean((emp.rho-semparms[j])^2))

  }
}


saremfegmtab <- list(ml=resmeanl, sl=ressdl, mr=resmeanr, sr=ressdr)
saremfegmtab2 <- list(ml=resbiasl, sl=resrmsel, mr=resbiasr, sr=resrmser)


#################### pretty-printing of results ########################

## convenience functions

restablemake <- function(means, sds, roundm=5, roundsd=3) {

  ## makes nice table of parameters with sd's underneath in ()

  ## puts number as text in brackets
  brack <- function(x) as.character(paste("(",x,")", sep=""))

 restable <- matrix(ncol=ncol(means), nrow=2*nrow(means))

  medie <- matrix(as.character(round(means,roundm)), ncol=ncol(means))
  essedi <- matrix(brack(round(sds,roundsd)), ncol=ncol(sds))

  restable[seq(1, nrow(means)*2-1, by=2) ,] <- medie
  restable[seq(2, nrow(means)*2, by=2) ,] <- essedi

  dimnames(restable)[[2]]<-paste("lambda=",sarparms, sep="")
  lab1 <- 1:6
  lab1[c(1,3,5)] <- paste("rho=",sarparms, sep="")
  dimnames(restable)[[1]]<-lab1

  restable
}


library(xtable)

## generate all tables of bias and RMSE (does not print when sourced!)

## re (Table 4, left and right)
xtable(restablemake(saremretab2[[1]], saremretab2[[2]]))
xtable(restablemake(saremretab2[[3]], saremretab2[[4]]))

## re2 (Table 6, idem)
xtable(restablemake(sarem2retab2[[1]], sarem2retab2[[2]]))
xtable(restablemake(sarem2retab2[[3]], sarem2retab2[[4]]))

## fe (Table 5, idem)
xtable(restablemake(saremfetab2[[1]], saremfetab2[[2]]))
xtable(restablemake(saremfetab2[[3]], saremfetab2[[4]]))

## re GM (Table 6, idem)
xtable(restablemake(saremregmtab2[[1]], saremregmtab2[[2]]))
xtable(restablemake(saremregmtab2[[3]], saremregmtab2[[4]]))

## fe GM (Table 6, idem)
xtable(restablemake(saremfegmtab2[[1]], saremfegmtab2[[2]]))
xtable(restablemake(saremfegmtab2[[3]], saremfegmtab2[[4]]))
